#ifndef MINUITCTOF_H
#define MINUITCTOF_H


#include "cfortran.h"

/* tcl defines a VOID macro that prevents cfortran headers from compiling */

#ifdef _TCL
#define VOIDTMP VOID
#undef VOID
#endif


PROTOCCALLSFSUB6(MNEXCM,mnexcm,ROUTINE,STRING,DOUBLEV,INT,PINT,INT)

PROTOCCALLSFSUB7(MNPARM,mnparm,INT,STRING,DOUBLE,DOUBLE,DOUBLE,DOUBLE,PINT)

PROTOCCALLSFSUB7(MNPOUT,mnpout,INT,PSTRING,PDOUBLE,PDOUBLE,PDOUBLE,PDOUBLE,PINT)

#define MNEXCM(MNCalcStat, command, darg, narg, ierr, null) \
		CCALLSFSUB6(MNEXCM,mnexcm,ROUTINE,STRING,DOUBLEV,INT,PINT,INT, \
			MNCalcStat, command, darg, narg, ierr, null)

#define MNPARM(ivar, name, val, err, bn1, bn2, ierr) \
		CCALLSFSUB7(MNPARM,mnparm,INT,STRING,DOUBLE,DOUBLE,DOUBLE, \
		DOUBLE,PINT, ivar, name, val, err, bn1, bn2, ierr)

#define MNPOUT(ivar, name, val, err, bn1, bn2, ierr) \
		CCALLSFSUB7(MNPOUT,mnpout,INT,PSTRING,PDOUBLE,PDOUBLE,PDOUBLE, \
		PDOUBLE,PINT, ivar, name, val, err, bn1, bn2, ierr)

extern "C"
{
   void mninit_(const int&, const int&, const int&);
   void mncalcstat_(int &nvpar, Real* grad, Real& chisq, Real* par,
   			int& iflag);
   void mncler_();
   void mnerrs_(const int& ivar, Real& eplus, Real& eminus, Real& eparab, Real& globcc);
   void mnfopn_(const int&);
   void mnflsh_(const int&, int& ierr);
   void mnfcls_(const int&); 
   void mnemat_(Real* emat, const int& ndim);
}

#endif
